<?php 
/* 
 * 	   Copyright 2010 WALTHER Jrmy & MOLE Bruno
 *    Zoku Server
 *    Version 1.0-beta
 *    
 *    Contact the authors :
 *    WALTHER Jrmy	: jeremy.walther@ftad.fr
 *    MOLE Bruno		: bruno.mole@ftad.fr
 *    
 *    This file is part of Zoku Server.
 *
 *    Zoku Server is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Zoku Server is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Zoku Server.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
?>
<?php

class ZS_Event extends ZS_Base
{
	public $id;
	public $name;
	public $starting_date;
	public $ending_date;
	public $type;
	public $address;
	public $city;
	public $zipcode;
	public $country;
	public $email;
	public $phone;
	public $website;
	public $logo;
	public $url;
	public $group_id;
	public $min_people;
	public $max_people;
	public $fees;
	public $create_date = 0;
	
	
	function __construct($row = "")
	{
		parent::__construct();
		if ($row != "")
		{
			$this->createFromArray($row);
		}
	}
	
	
	public function createFromArray($array)
	{
		if (isset($array['id']))			{ $this->id = $array['id']; };
		if (isset($array['name']))			{ $this->name = $array['name']; };
		if (isset($array['starting_date']))	{ $this->starting_date = $array['starting_date']; };
		if (isset($array['ending_date']))	{ $this->ending_date = $array['ending_date']; };
		if (isset($array['type']))			{ $this->type = $array['type']; };
		if (isset($array['address']))		{ $this->address = $array['address']; };
		if (isset($array['city']))			{ $this->city = $array['city']; };
		if (isset($array['zipcode']))		{ $this->zipcode = $array['zipcode']; };
		if (isset($array['country']))		{ $this->country = $array['country']; };
		if (isset($array['email']))			{ $this->email = $array['email']; };
		if (isset($array['phone']))			{ $this->phone = $array['phone']; };
		if (isset($array['website']))		{ $this->website = $array['website']; };
		if (isset($array['url']))			{ $this->url = $array['url']; };
		if (isset($array['group_id']))		{ $this->group_id = $array['group_id']; };
		if (isset($array['min_people']))	{ $this->min_people = $array['min_people']; };
		if (isset($array['max_people']))	{ $this->max_people = $array['max_people']; };
		if (isset($array['fees']))			{ $this->fees = $array['fees']; };
		if (isset($array['create_date']))	{ $this->create_date = $array['create_date']; };
		return true;
	}
	
	
	public function delete()
	{
		return $this->getDBLink()->query("DELETE FROM `".$this->getDBPrefix()."_event` WHERE `id` = '$this->id'");
	}
	
	
	public function selectById($id)
	{
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_event` WHERE `id` = '$id'"))
		{
			if($row = $this->getDBLink()->fetch($result))
			{
				return $this->createFromArray($row);
			}
			
		}
		return false;
	}
	
	
	public function createInDB()
	{
		$result =  $this->getDBLink()->query("INSERT INTO `".$this->getDBPrefix()."_event` 
		(`name`, `starting_date`, `ending_date`, `type`, `address`, `city`, 
		 `zipcode`, `country`, `email`, `phone`, `website`, `url`, `group_id`,
		 `min_people`, `max_people`, `fees`, `create_date`) 
		VALUES 
		('$this->name', '$this->starting_date', '$this->ending_date', '$this->type',
		 '$this->address', '$this->city', '$this->zipcode', '$this->country',
		 '$this->email', '$this->phone', '$this->website', '$this->url',
		 '$this->group_id', '$this->min_people', '$this->max_people', '$this->fees', '".time()."')");
		if ($result)
		{
			$this->id = $this->getDBLink()->lastId();
		}
		return $result;
	}
	
	
	public function updateIntoDB()
	{
		return $this->getDBLink()->query("UPDATE `".$this->getDBPrefix()."_event` SET 		
		`name` = '$this->name', 
		`starting_date` = '$this->starting_date', 
		`ending_date` = '$this->ending_date',
		`type` = '$this->type',
		`address` = '$this->address',
		`city` = '$this->city',
		`zipcode` = '$this->zipcode',
		`country` = '$this->country',
		`email` = '$this->email',
		`phone` = '$this->phone',
		`website` = '$this->website',
		`url` = '$this->url',
		`group_id` = '$this->group_id',
		`min_people` = '$this->min_people',
		`max_people` = '$this->max_people',
		`fees` = '$this->fees' WHERE `id` = '$this->id'");
	}
	
	
	public function getVars()
	{
		return get_object_vars($this);
	}
	
	public function selectVars($vars)
	{
		// TODO
		// faut retourner les variables PUBLIC si le mec est pas connect, et PRIVATE s'il l'est
		// donc une fois le systme de session oprationnel, on fait cette mthode ...
	}
	
	public function getPublicVars()
	{
		global $zs_classes_vars_info;
		$vars = $this->getVars();
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'PUBLIC') === FALSE))
			{
				$result[$key] = $vars[$key];
			}
		}
		return $result;
	}
	
	public function getPrivateVars()
	{
		global $zs_classes_vars_info;
		$vars = $this->getVars();
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'PRIVATE') === FALSE))
			{
				$result[$key] = $vars[$key];
			}
		}
		return $result;
	}
	
	public function checkConsistency()
	{
		// TODO
		$required = $this->getRequiredVarNames();
		$vars = $this->getVars();
		$i = 0;
		foreach ($required as $key => $value)
		{
			if (isset($vars[$value]) && trim($vars[$value]) != "" && $vars[$value] != -1)
			{
				$i++;
			}
		}
		if ($i == count($required))
		{
			return true;
		}
		return false;
	}
	
	public function getRequiredVarNames()
	{
		global $zs_classes_vars_info;
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'REQUIRED') === FALSE))
			{
				$result[] = $key;
			}
		}
		return $result;
	}	
	
	public function getUsedVars()
	{
		global $zs_classes_vars_info;
		$vars = $this->getVars();
		$result = array();
		foreach ($zs_classes_vars_info[__CLASS__] as $key => $value)
		{
			if (!(strpos($value, 'USED') === FALSE))
			{
				$result[$key] = $vars[$key];
			}
		}
		return $result;
	}
	
	public function getMembers()
	{
		if ($sql = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_eventmember WHERE `event_id` = '$this->id'"))
		{
			$members = array();
			while ($row = $this->getDBLink()->fetch($sql))
			{
				$members[] = $row;
			}
			return $row;
		}
		return false;
	}
	
	public function getMissingVars()
	{
		$required = $this->getRequiredVarNames();
		$vars = $this->getVars();
		$missing = array();
		foreach ($required as $key => $value)
		{
			if (!(isset($vars[$value]) && $vars[$value] != "" && $vars[$value] != -1 && !empty($vars[$value])))
			{
				$missing[] = $value;
			}
		}
		return $missing;
	}
	
	public function getLastSince($date)
	{
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_event` WHERE `create_date` >= '$date' ORDER BY `create_date` DESC"))
		{
			$array = array();
			while ($row = $this->getDBLink()->fetch($result))
			{
				$event = new ZS_Event($row);
				$array[] = $event->getPublicVars();
			}
			return $array;
		}
		return false;
	}
}

?>