<?php 
/* 
 * 	   Copyright 2010 WALTHER Jrmy & MOLE Bruno
 *    Zoku Server
 *    Version 1.0-beta
 *    
 *    Contact the authors :
 *    WALTHER Jrmy	: jeremy.walther@ftad.fr
 *    MOLE Bruno		: bruno.mole@ftad.fr
 *    
 *    This file is part of Zoku Server.
 *
 *    Zoku Server is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Zoku Server is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Zoku Server.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
?>
<?php 

/**
 * 
 * @author Golf Lima
 * @deprecated
 */
class ZS_Mail extends ZS_Base
{
	public $from = "";
	public $to = "";
	public $subject = "";
	public $text = "";
	public $html = "";
	public $message = "";
	public $headers = "";
	public $parameters = "";
	public $useHTML = true;
	
	function __construct($row = "")
	{
		parent::__construct();
		if ($row != "")
		{
			$this->createFromArray($row);
		}
	}
	
	public function createFromArray($array)
	{
		if (isset($array['to']))			{ $this->to = $array['to']; };
		if (isset($array['subject']))		{ $this->subject = $array['subject']; };
		if (isset($array['message']))		{ $this->message = $array['message']; };
		if (isset($array['headers']))		{ $this->headers = $array['headers']; };
		if (isset($array['parameters']))	{ $this->parameters = $array['parameters']; };
		if (isset($array['useHTML']))		{ $this->useHTML = $array['useHTML']; };
		return true;
	}
	
	public function send()
	{
		$this->build();
		//return mail($this->to, $this->subject, $this->message, $this->headers, $this->parameters);
		return mail($this->to, $this->subject, $this->message, $this->headers);
	}
	
	public function setFrom($email, $name = "")
	{
		$this->from = "From: ";
		if ($name != "")
		{
			$this->from .= '"'.$this->formatString($name).'" ';
		}
		$this->from .= "<$email>\r\n";
	}
	
	public function addTo($email, $name = "")
	{
		if ($name != "")
		{
			$this->to .= '"'.$this->formatString($name).'" ';
		}
		$this->to .= "<$email>, ";
	}
	
	public function append($content)
	{
		if (is_string($content) || is_numeric($content))
		{
			$this->text .= $this->formatString($content)."\n";
			$this->html .= "<p>".$this->formatString($content)."</p>\n";
			return true;
		}
		
		if (is_array($content))
		{
			$this->html .= "<ul>\n";
			foreach ($content as $key => $value)
			{
				$this->text .= "\t".$this->formatString($key)."\t=\t".$this->formatString($value)."\n";
				$this->html .= "<li>".$this->formatString($key)." = ".$this->formatString($value)."</li>\n";
			}
			$this->html .= "</ul>\n";
			return true;
		}
		return false;
	}
	
	public function setSubject($subject)
	{
		$this->subject = $this->formatString($subject);
	}
	
	public function build()
	{
		$boundary = '-----=' . md5(uniqid(mt_rand())); 
		
		$this->headers = $this->from;
    	$this->headers .= 'MIME-Version: 1.0'."\r\n";
     	$this->headers .= 'Content-Type: multipart/alternative; boundary="'.$boundary.'"'."\r\n"; 
		
		$this->message = 'This is a multi-part message in MIME format.'."\n\n";
		
		$this->message .= '--'.$boundary.'--'."\n";
		
		$this->message .= 'Content-Type: text/plain; charset="UTF-8"'."\n";
		$this->message .= 'Content-Transfer-Encoding: quoted-printable'."\n\n";
		$this->message .= $this->text."\n\n";
		
		$this->message .= '--'.$boundary.'--'."\n";
		$this->message .= 'Content-Type: text/html; charset="UTF-8"'."\n";
		$this->message .= 'Content-Transfer-Encoding: quoted-printable'."\n\n";
		$this->message .= "<html><body>\n$this->html</boby></html>\n\n";
		
		$this->message .= '--'.$boundary.'--'."\n"; 
	}
	
	public function getVars()
	{
		return get_object_vars($this);
	}
	
	public function formatString($string)
	{
		$string = utf8_encode($string);
		return $string;
	}
}

?>